

function sigma=IMPV_NR(S, K, r, T, Value,ipotesi,N)

n=length(Value);

for k=1:1:n
        

sigma(k)=ipotesi;


i=1;

while ((N-i)*sigma>0)
   
       
    [C,P]=feval(@blackprice,S,K(k),r,T,sigma(k));
    
  
    V=feval(@Vega,S,K(k),r,sigma(k),T);

      
    sigma(k)=sigma(k)-(C-Value(k))/V;
    
    i=i+1;
    
end


    if (sigma(k)<=0)
        
        sigma(k)=NaN;
        
    end
       
end    
    

    function  [C,P]=blackprice(S,K,r,T,sigma)
    
        d1=(log(S/K)+(r+0.5*sigma^2)*T)/(sigma*sqrt(T));
    
        d2=d1-sigma*sqrt(T);
        
            C=S*normcdf(d1,0,1)-K*exp(-r*T)*normcdf(d2);
            
            P=K*exp(-r*T)-S+C;
                 
    
    
    function y=Vega(S,K,r,sigma,T)

    
        d1=(log(S/K)+(r+0.5*sigma^2)*T)/(sigma*sqrt(T));
        
        y=S*sqrt(T)*exp(-0.5*d1*d1)/sqrt(2*pi);
        
        
        
