
% Monte Carlo

function y=MC(S,K,r,T,sigma,Nsce);



 for k=1:1:Nsce

  w = normrnd(0,1);

  ST=S.*exp((r-0.5*sigma*sigma)*T+sigma*sqrt(T)*w);

  Payoff(k)=max(ST-K,0);

 
end

y=exp(-r*T)*sum(Payoff)/Nsce;




  function  [C,P]=blackprice(S,K,r,T,sigma)
    
         d1=(log(S/K)+(r+0.5*sigma^2)*T)/(sigma*sqrt(T));
    
         d2=d1-sigma*sqrt(T);
         
            C=S*normcdf(d1,0,1)-K*exp(-r*T)*normcdf(d2);
            
            P=K*exp(-r*T)-S+C;
                 
    